package vectorgyakorlo;
import java.util.*;

public class Main {

    public static void main(String[] args) {
        Vector<Integer> szamok = new Vector<Integer>();
        szamok.add(5); //vector bővítése egy elemmel
        szamok.add(8);
        szamok.add(2);
        szamok.add(1);
        szamok.add(7);

        System.out.println(szamok); //vektor elemeinek kiíratása
        
        System.out.println(szamok.get(1)); //a vektor második elemének kiíratása

        szamok.set(1, 10); //adott indexű elem módosítása
        System.out.println(szamok);
        
        szamok.remove(4); //adott elem törlése index alapján
        System.out.println(szamok);

        System.out.println(szamok.isEmpty()); //üres-e a tömb?
        System.out.println(szamok.contains(5)); //tartalmazza-e az adott elemet?
        System.out.println(szamok.indexOf(10)); //hanyadik helyen van a kerestt elem (első előfordulás). Ha nincs benne az elem, akkor -1 -et ad vissza.

        szamok.add(10);
        System.out.println(szamok.lastIndexOf(10)); //hanyadik helyen van a kerestt elem (utolsó előfordulás).

        System.out.println(szamok.size()); //a tömb méretét adja vissza

        szamok.clear(); //összes elem törlése
        System.out.println(szamok);


        ///////////////////////////////////////////
        // Sztring típusú vektor
        ///////////////////////////////////////////
        Vector<String> szoveg = new Vector<String>();
        szoveg.add("abc");
        szoveg.add("asd");
        szoveg.add("qwe");
        szoveg.add("123");
        System.out.println(szoveg);
        System.out.println(szoveg.size());
        System.out.println(szoveg.get(2));
        System.out.println(szoveg.indexOf("asd"));


        ///////////////////////////////////////////
        // Saját osztály típusú vektor
        ///////////////////////////////////////////
        Vector<Termek> termekek = new Vector<Termek>();

        //1. módszer:
        //osztály hozzáadása előtt egy konkrét példányt kell létrehozni és azt átadni az add metódusnak. Minden egyes elemnél új példányt kell létrehozni, mert különben ugyanarra a memóriacímre mutatnak.
        Termek labda = new Termek(1,"pöttyös labda",10,7999);
        Termek labda2 = new Termek(1,"pöttyös labda",10,7999);
        termekek.add(labda); //példány hozzáadása
        termekek.add(labda2); //példány hozzáadása még 1*
        System.out.println(termekek);

        //2. módszer (névtelen objektum átadása az add metódusnak):
        termekek.add(new Termek(3,"gumikacsa",5,4999));
        termekek.add(new Termek(3,"gumikacsa",5,4999));
        System.out.println(termekek);

        //a vektorban lévő második indexű termék (gumikacsa) súlyának lekérése
        System.out.println(termekek.get(2).suly);

        //gumikacsa megkeresése
        //1. módszer: for ciklussal végigmegyek amíg meg nem találom
        for (int i=0; i<termekek.size(); i++) {
            if (termekek.get(i).nev == "gumikacsa") {
                System.out.println("gumikacsa indexe: "+i);
                break;
            }
        }

        //2. módszer: A Termek osztályhoz készítek egy equals metódust, majd a vektorban indexOf metódus használata
        System.out.println(termekek.indexOf(new Termek(0,"gumikacsa",0,0)));

        //Minden termék árát megnöveljük 500-al: Termékenként meghívjuk az emelAr metódust 500 aktuális paraméterrel
        for (int i=0; i<termekek.size(); i++) {
            termekek.get(i).emelAr(500);
        }
        System.out.println(termekek);
    }

}
